diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java
index 6d9e951f4..0db20ff71 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceGate.java
@@ -1,16 +1,14 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.block.color.BlockColorDispatcher;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicFenceGate;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
-import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBd;
-import org.lwjgl.opengl.GL11;
 import org.useless.dragonfly.DisplayPos;
 
 public class BlockModelFenceGate<T extends BlockLogicFenceGate> extends BlockModelStandard<T> {
@@ -25,7 +23,7 @@ public class BlockModelFenceGate<T extends BlockLogicFenceGate> extends BlockMod
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         AABBd bounds = new AABBd(this.block.getBounds());
         boolean flag = true;
         int meta = worldSource.getBlockData(tilePos);
@@ -159,58 +157,39 @@ public class BlockModelFenceGate<T extends BlockLogicFenceGate> extends BlockMod
     }
 
     @Override
-    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        if (renderBlocks.useInventoryTint) {
-            int j = BlockColorDispatcher.getInstance().getDispatch(this.block).getFallbackColor(metadata, 0);
-            float f1 = (float) (j >> 16 & 0xff) / 255F;
-            float f3 = (float) (j >> 8 & 0xff) / 255F;
-            float f5 = (float) (j & 0xff) / 255F;
-            GL11.glColor4f(f1 * brightness, f3 * brightness, f5 * brightness, alpha);
-        }
-        for (int k1 = 0; k1 < 3; k1++) {
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
+        tessellator.offsetTranslation(-0.5, -0.5, -0.5);
+        tessellator.startDrawingQuads();
+        tessellator.setColor1i(getStandaloneTintColor(metadata));
+        for (int bar = 0; bar < 3; bar++) {
             float f6 = 0.0625F;
             AABBd bounds = new AABBd(this.block.getBounds());
-            if (k1 == 0) {
-                bounds.setMin(0.5F - f6, 0.3F, 0.0F).setMax(0.5F + f6, 1.0F, f6 * 2.0F);
-            }
-            if (k1 == 1) {
-                bounds.setMin(0.5F - f6, 0.3F, 1.0F - f6 * 2.0F).setMax(0.5F + f6, 1.0F, 1.0F);
+            switch (bar) {
+                case 0 -> bounds.setMin(0.5F - f6, 0.3F, 0.0F).setMax(0.5F + f6, 1.0F, f6 * 2.0F);
+                case 1 -> bounds.setMin(0.5F - f6, 0.3F, 1.0F - f6 * 2.0F).setMax(0.5F + f6, 1.0F, 1.0F);
+                default -> bounds.setMin(0.5F - f6, 0.5F, 0.0F).setMax(0.5F + f6, 1.0F - f6, 1.0F);
             }
-            if (k1 == 2) {
-                bounds.setMin(0.5F - f6, 0.5F, 0.0F).setMax(0.5F + f6, 1.0F - f6, 1.0F);
-            }
-            GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
-            tessellator.startDrawingQuads();
+
             tessellator.setNormal(0.0F, -1F, 0.0F);
             renderBlocks.renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata));
-            tessellator.draw();
 
-            tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 1.0F, 0.0F);
             renderBlocks.renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.TOP, metadata));
-            tessellator.draw();
 
-            tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 0.0F, -1F);
             renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.NORTH, metadata));
-            tessellator.draw();
 
-            tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 0.0F, 1.0F);
             renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.SOUTH, metadata));
-            tessellator.draw();
 
-            tessellator.startDrawingQuads();
             tessellator.setNormal(-1F, 0.0F, 0.0F);
             renderBlocks.renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.WEST, metadata));
-            tessellator.draw();
 
-            tessellator.startDrawingQuads();
             tessellator.setNormal(1.0F, 0.0F, 0.0F);
             renderBlocks.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
-            tessellator.draw();
-            GL11.glTranslatef(0.5F, 0.5F, 0.5F);
         }
+        tessellator.draw();
+        tessellator.offsetTranslation(0.5, 0.5, 0.5);
     }
 
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
index d1647fb68..2f1010beb 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFenceThin.java
@@ -1,9 +1,10 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.block.color.BlockColorDispatcher;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicFenceThin;
 import net.minecraft.core.util.helper.Side;
@@ -12,8 +13,8 @@ import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Math;
 import org.joml.primitives.AABBd;
-import org.lwjgl.opengl.GL11;
 import org.useless.dragonfly.DisplayPos;
 
 public class BlockModelFenceThin<T extends BlockLogicFenceThin> extends BlockModelStandard<T> {
@@ -34,14 +35,10 @@ public class BlockModelFenceThin<T extends BlockLogicFenceThin> extends BlockMod
     }
 
     @Override
-    public boolean render(@NotNull Tessellator t, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain t, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         float brightness = 1.0f;
-        if (LightmapHelper.isLightmapEnabled()) {
-            t.setLightmapCoord(this.block.getLightmapCoord(worldSource, tilePos));
-        } else {
-            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
-        }
-        t.setColorOpaque_F(brightness, brightness, brightness);
+        t.setLightmapCoord1i(this.block.getLightmapCoord(worldSource, tilePos));
+        t.setColorOpaque3f(brightness, brightness, brightness);
 
         TilePos queryPos = new TilePos();
 
@@ -121,7 +118,7 @@ public class BlockModelFenceThin<T extends BlockLogicFenceThin> extends BlockMod
             float maxZ = tilePos.z() + ((16 / 2f) + (2 / 2f)) / 16f;
 
             // Render sides
-            t.setColorOpaque_F(cNorthSouth * brightness, cNorthSouth * brightness, cNorthSouth * brightness);
+            t.setColorOpaque3f(cNorthSouth * brightness, cNorthSouth * brightness, cNorthSouth * brightness);
             t.addVertexWithUV(maxX, minY, minZ, sidesMinU, sidesMaxV);
             t.addVertexWithUV(minX, minY, minZ, sidesMaxU, sidesMaxV);
             t.addVertexWithUV(minX, maxY, minZ, sidesMaxU, sidesMinV);
@@ -132,7 +129,7 @@ public class BlockModelFenceThin<T extends BlockLogicFenceThin> extends BlockMod
             t.addVertexWithUV(maxX, maxY, maxZ, sidesMaxU, sidesMinV);
             t.addVertexWithUV(minX, maxY, maxZ, sidesMinU, sidesMinV);
 
-            t.setColorOpaque_F(cEastWest * brightness, cEastWest * brightness, cEastWest * brightness);
+            t.setColorOpaque3f(cEastWest * brightness, cEastWest * brightness, cEastWest * brightness);
             t.addVertexWithUV(maxX, minY, maxZ, sidesMinU, sidesMaxV);
             t.addVertexWithUV(maxX, minY, minZ, sidesMaxU, sidesMaxV);
             t.addVertexWithUV(maxX, maxY, minZ, sidesMaxU, sidesMinV);
@@ -149,14 +146,14 @@ public class BlockModelFenceThin<T extends BlockLogicFenceThin> extends BlockMod
             double topBottomMaxV = this.columnTexIndex.getSubIconV(onePix * 2);
 
             // Render top
-            t.setColorOpaque_F(cTop * brightness, cTop * brightness, cTop * brightness);
+            t.setColorOpaque3f(cTop * brightness, cTop * brightness, cTop * brightness);
             t.addVertexWithUV(minX, maxY, maxZ, topBottomMinU, topBottomMaxV);
             t.addVertexWithUV(maxX, maxY, maxZ, topBottomMaxU, topBottomMaxV);
             t.addVertexWithUV(maxX, maxY, minZ, topBottomMaxU, topBottomMinV);
             t.addVertexWithUV(minX, maxY, minZ, topBottomMinU, topBottomMinV);
 
             // Render bottom
-            t.setColorOpaque_F(cBottom * brightness, cBottom * brightness, cBottom * brightness);
+            t.setColorOpaque3f(cBottom * brightness, cBottom * brightness, cBottom * brightness);
             t.addVertexWithUV(minX, minY, minZ, topBottomMinU, topBottomMinV);
             t.addVertexWithUV(maxX, minY, minZ, topBottomMaxU, topBottomMinV);
             t.addVertexWithUV(maxX, minY, maxZ, topBottomMaxU, topBottomMaxV);
@@ -193,7 +190,7 @@ public class BlockModelFenceThin<T extends BlockLogicFenceThin> extends BlockMod
             float maxY = tilePos.y() + 1.0f;
             float maxZ = tilePos.z() + (8f / 16f);
 
-            t.setColorOpaque_F(cEastWest * brightness, cEastWest * brightness, cEastWest * brightness);
+            t.setColorOpaque3f(cEastWest * brightness, cEastWest * brightness, cEastWest * brightness);
             t.addVertexWithUV(maxX, minY, maxZ, sidesMinU, sidesMaxV);
             t.addVertexWithUV(maxX, minY, minZ, sidesMaxU, sidesMaxV);
             t.addVertexWithUV(maxX, maxY, minZ, sidesMaxU, sidesMinV);
@@ -235,7 +232,7 @@ public class BlockModelFenceThin<T extends BlockLogicFenceThin> extends BlockMod
             float maxY = tilePos.y() + 1.0f;
             float maxZ = tilePos.z() + 1.0f;
 
-            t.setColorOpaque_F(cEastWest * brightness, cEastWest * brightness, cEastWest * brightness);
+            t.setColorOpaque3f(cEastWest * brightness, cEastWest * brightness, cEastWest * brightness);
             t.addVertexWithUV(maxX, minY, maxZ, sidesMinU, sidesMaxV);
             t.addVertexWithUV(maxX, minY, minZ, sidesMaxU, sidesMaxV);
             t.addVertexWithUV(maxX, maxY, minZ, sidesMaxU, sidesMinV);
@@ -277,7 +274,7 @@ public class BlockModelFenceThin<T extends BlockLogicFenceThin> extends BlockMod
             float maxY = tilePos.y() + 1.0f;
             float maxZ = tilePos.z() + (8f / 16f);
 
-            t.setColorOpaque_F(cNorthSouth * brightness, cNorthSouth * brightness, cNorthSouth * brightness);
+            t.setColorOpaque3f(cNorthSouth * brightness, cNorthSouth * brightness, cNorthSouth * brightness);
             t.addVertexWithUV(maxX, minY, minZ, sidesMinU, sidesMaxV);
             t.addVertexWithUV(minX, minY, minZ, sidesMaxU, sidesMaxV);
             t.addVertexWithUV(minX, maxY, minZ, sidesMaxU, sidesMinV);
@@ -319,7 +316,7 @@ public class BlockModelFenceThin<T extends BlockLogicFenceThin> extends BlockMod
             float maxY = tilePos.y() + 1.0f;
             float maxZ = tilePos.z() + (8f / 16f);
 
-            t.setColorOpaque_F(cNorthSouth * brightness, cNorthSouth * brightness, cNorthSouth * brightness);
+            t.setColorOpaque3f(cNorthSouth * brightness, cNorthSouth * brightness, cNorthSouth * brightness);
             t.addVertexWithUV(maxX, minY, minZ, sidesMinU, sidesMaxV);
             t.addVertexWithUV(minX, minY, minZ, sidesMaxU, sidesMaxV);
             t.addVertexWithUV(minX, maxY, minZ, sidesMaxU, sidesMinV);
@@ -335,64 +332,49 @@ public class BlockModelFenceThin<T extends BlockLogicFenceThin> extends BlockMod
     }
 
     @Override
-    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        if (renderBlocks.useInventoryTint) {
-            int color = BlockColorDispatcher.getInstance().getDispatch(this.block).getFallbackColor(metadata, 0);
-            float r = (float) (color >> 16 & 0xff) / 255F;
-            float g = (float) (color >> 8 & 0xff) / 255F;
-            float b = (float) (color & 0xff) / 255F;
-            GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
-        }
-        GL11.glRotatef(90, 0, 1, 0);
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
+        int color = getStandaloneTintColor(metadata);
+        GLRenderer.modelM4f().rotateY(Math.toRadians(90));
         AABBd bounds = new AABBd(0, 0, 0, 1, 1, 1);
         for (int i1 = 0; i1 < 2; i1++) {
-            GL11.glPushMatrix();
+            GLRenderer.pushFrame();
             float f4 = 0.125F / 2;
             bounds.setMin(0, 0.0F, 0.0F).setMax(2 * f4, 1.0F, f4 * 2.0F);
-            GL11.glTranslatef(0.5f - f4, 0, 0);
+            GLRenderer.modelM4f().translate(0.5f - f4, 0, 0);
             if (i1 == 1) {
-                GL11.glTranslatef(0, 0, 1f - (f4 * 2));
+                GLRenderer.modelM4f().translate(0, 0, 1f - (f4 * 2));
             }
-            GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
+            GLRenderer.modelM4f().translate(-0.5F, -0.5F, -0.5F);
             tessellator.startDrawingQuads();
+            tessellator.setColor1i(color);
             tessellator.setNormal(0.0F, -1F, 0.0F);
             renderBlocks.renderBottomFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, this.columnTexIndex);
-            tessellator.draw();
 
-            tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 1.0F, 0.0F);
             renderBlocks.renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, this.columnTexIndex);
-            tessellator.draw();
 
-            tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 0.0F, -1F);
             renderBlocks.renderNorthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, this.columnTexIndex);
-            tessellator.draw();
 
-            tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 0.0F, 1.0F);
             renderBlocks.renderSouthFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, this.columnTexIndex);
-            tessellator.draw();
 
-            tessellator.startDrawingQuads();
             tessellator.setNormal(-1F, 0.0F, 0.0F);
             renderBlocks.renderWestFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, this.columnTexIndex);
-            tessellator.draw();
 
-            tessellator.startDrawingQuads();
             tessellator.setNormal(1.0F, 0.0F, 0.0F);
             renderBlocks.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, this.columnTexIndex);
             tessellator.draw();
-            GL11.glPopMatrix();
+            GLRenderer.popFrame();
         }
 
-        GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
-        GL11.glDisable(GL11.GL_CULL_FACE);
+        GLRenderer.modelM4f().translate(-0.5F, -0.5F, -0.5F);
+        GLRenderer.disableState(State.CULL_FACE);
         bounds.setMin(0, 0, 0).setMax(0.5f, 1, 1);
         tessellator.startDrawingQuads();
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
         renderBlocks.renderEastFace(tessellator, bounds, 0, 0, 0, this.texIndex);
         tessellator.draw();
-        GL11.glTranslatef(0.5F, 0.5F, 0.5F);
+        GLRenderer.modelM4f().translate(0.5F, 0.5F, 0.5F);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
index cd535bb6d..058d5f2b3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFire.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.world.WorldClient;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
@@ -27,18 +27,12 @@ public class BlockModelFire<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         IconCoordinate tex = getBlockTextureFromSideAndMetadata(Side.BOTTOM, worldSource.getBlockData(tilePos));
         if (renderBlocks.overrideBlockTexture != null) {
             tex = renderBlocks.overrideBlockTexture;
         }
-        float brightness = 1.0f;
-        if (LightmapHelper.isLightmapEnabled()) {
-            tessellator.setLightmapCoord(LightmapHelper.getOverbrightLightmapCoord(worldSource.getSavedLightValue(LightLayer.Sky, tilePos)));
-        } else {
-            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
-        }
-        tessellator.setColorOpaque_F(brightness, brightness, brightness);
+        tessellator.setLightmapCoord1i(LightmapHelper.getOverbrightLightmapCoord(worldSource.getSavedLightValue(LightLayer.Sky, tilePos)));
         double uMin = tex.getIconUMin();
         double uMax = tex.getIconUMax();
         double vMin = tex.getIconVMin();
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
index 6c6ebda32..ecd4a7058 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
@@ -2,8 +2,8 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
-import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogicFluid;
 import net.minecraft.core.block.material.Material;
@@ -22,7 +22,7 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         int color = BlockColorDispatcher.getInstance().getDispatch(this.block).getWorldColor(worldSource, tilePos, 0);
         float r = (float) (color >> 16 & 0xff) / 255F;
         float g = (float) (color >> 8 & 0xff) / 255F;
@@ -69,14 +69,10 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
                 rotation = 0.0F;
             }
             float blockBrightness = 1.0f;
-            if (LightmapHelper.isLightmapEnabled()) {
-                int light = this.block.getLightmapCoord(worldSource, tilePos);
-                int lightUp = this.block.getLightmapCoord(worldSource, tilePos.up(queryPos));
+            int light = this.block.getLightmapCoord(worldSource, tilePos);
+            int lightUp = this.block.getLightmapCoord(worldSource, tilePos.up(queryPos));
 
-                tessellator.setLightmapCoord(LightmapHelper.max(light, lightUp));
-            } else {
-                blockBrightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
-            }
+            tessellator.setLightmapCoord1i(LightmapHelper.max(light, lightUp));
             if (texture.namespaceId.toString().contains("_flowing")) {
                 double centerU = texture.getSubIconU(0.5);
                 double centerV = texture.getSubIconV(0.5);
@@ -88,13 +84,13 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
                 double minV = texture.getIconVMin();
                 double maxV = texture.getIconVMax();
 
-                tessellator.setColorOpaque_F(sideTop * blockBrightness * r, sideTop * blockBrightness * g, sideTop * blockBrightness * b);
+                tessellator.setColorOpaque3f(sideTop * blockBrightness * r, sideTop * blockBrightness * g, sideTop * blockBrightness * b);
                 tessellator.addVertexWithUV(x, (float) y + f7, z, ((minU - centerU) * sin - (maxV - centerV) * cSin) + centerU, ((maxV - centerV) * sin + (minU - centerU) * cSin) + centerV);
                 tessellator.addVertexWithUV(x, (float) y + f8, z + 1, ((maxU - centerU) * sin - (maxV - centerV) * cSin) + centerU, ((maxV - centerV) * sin + (maxU - centerU) * cSin) + centerV);
                 tessellator.addVertexWithUV(x + 1, (float) y + f9, z + 1, ((maxU - centerU) * sin - (minV - centerV) * cSin) + centerU, ((minV - centerV) * sin + (maxU - centerU) * cSin) + centerV);
                 tessellator.addVertexWithUV(x + 1, (float) y + f10, z, ((minU - centerU) * sin - (minV - centerV) * cSin) + centerU, ((minV - centerV) * sin + (minU - centerU) * cSin) + centerV);
             } else {
-                tessellator.setColorOpaque_F(sideTop * blockBrightness * r, sideTop * blockBrightness * g, sideTop * blockBrightness * b);
+                tessellator.setColorOpaque3f(sideTop * blockBrightness * r, sideTop * blockBrightness * g, sideTop * blockBrightness * b);
                 tessellator.addVertexWithUV(x, (float) y + f7, z, texture.getIconUMin(), texture.getIconVMax());
                 tessellator.addVertexWithUV(x, (float) y + f8, z + 1, texture.getIconUMax(), texture.getIconVMax());
                 tessellator.addVertexWithUV(x + 1, (float) y + f9, z + 1, texture.getIconUMax(), texture.getIconVMin());
@@ -104,12 +100,8 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
         }
         if (renderBlocks.renderAllFaces || flag1) {
             float brightness = 1.0f;
-            if (LightmapHelper.isLightmapEnabled()) {
-                tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, tilePos.down(queryPos)));
-            } else {
-                brightness = renderBlocks.getBlockBrightness(worldSource, tilePos.down(queryPos));
-            }
-            tessellator.setColorOpaque_F(sideBottom * brightness * r, sideBottom * brightness * g, sideBottom * brightness * b);
+            tessellator.setLightmapCoord1i(this.block.getLightmapCoord(worldSource, tilePos.down(queryPos)));
+            tessellator.setColorOpaque3f(sideBottom * brightness * r, sideBottom * brightness * g, sideBottom * brightness * b);
 
             renderBlocks.renderBottomFace(tessellator, bounds, x, y + yOff, z, getBlockTextureFromSideAndMetadata(Side.TOP, 0));
             didRender = true;
@@ -176,17 +168,13 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
             double d7 = texture.getSubIconV(0.5F - f15 / 2 + vOff);
             double d8 = texture.getSubIconV(0.5F + vOff);
             float brightness = 1.0f;
-            if (LightmapHelper.isLightmapEnabled()) {
-                tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, posB));
-            } else {
-                brightness = renderBlocks.getBlockBrightness(worldSource, posB);
-            }
+            tessellator.setLightmapCoord1i(this.block.getLightmapCoord(worldSource, posB));
             if (side < 2) {
                 brightness *= sideNorthSouth;
             } else {
                 brightness *= sideEastWest;
             }
-            tessellator.setColorOpaque_F(sideTop * brightness * r, sideTop * brightness * g, sideTop * brightness * b);
+            tessellator.setColorOpaque3f(sideTop * brightness * r, sideTop * brightness * g, sideTop * brightness * b);
             tessellator.addVertexWithUV(f17, (float) y + f13, f19, d4, d6);
             tessellator.addVertexWithUV(f20, (float) y + f15, f21, d5, d7);
             tessellator.addVertexWithUV(f20, y, f21, d5, d8);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
index c7dc78262..03e3e9ba9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFullyRotatable.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.block.model;
 
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
@@ -18,7 +19,7 @@ public class BlockModelFullyRotatable<T extends BlockLogic> extends BlockModelSt
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(@NotNull TessellatorTerrain tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         final int meta = worldSource.getBlockData(tilePos);
         final Direction dir = BlockLogicFullyRotatable.metaToDirection(meta);
 
@@ -64,8 +65,8 @@ public class BlockModelFullyRotatable<T extends BlockLogic> extends BlockModelSt
 
 
     @Override
-    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        super.renderStandalone(tessellator, 1, brightness, alpha, lightmapCoordinate);
+    public void renderStandalone(@NotNull TessellatorGeneral tessellator, int metadata, int lightmapCoord) {
+        super.renderStandalone(tessellator, 1, lightmapCoord);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGeneric.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGeneric.java
index 23dbdad33..ec63ebae1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGeneric.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGeneric.java
@@ -1,7 +1,8 @@
 package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
+import net.minecraft.client.render.tessellator.TessellatorTerrain;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
@@ -28,7 +29,7 @@ public class BlockModelGeneric<T extends BlockLogic> extends BlockModel<T> {
     }
 
     @Override
-    public boolean renderNoCulling(@NotNull final Tessellator tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean renderNoCulling(@NotNull final TessellatorGeneral tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos) {
         return this.staticModel.renderAttached(this,
             tessellator,
             worldSource,
@@ -39,7 +40,7 @@ public class BlockModelGeneric<T extends BlockLogic> extends BlockModel<T> {
     }
 
     @Override
-    public boolean render(@NotNull final Tessellator tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean render(final @NotNull TessellatorTerrain tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos) {
         return this.staticModel.renderAttached(this,
             tessellator,
             worldSource,
@@ -50,12 +51,12 @@ public class BlockModelGeneric<T extends BlockLogic> extends BlockModel<T> {
     }
 
     @Override
-    public boolean renderOverbright(@NotNull final Tessellator tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos) {
+    public boolean renderOverbright(final @NotNull TessellatorTerrain tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos) {
         throw new UnsupportedOperationException();
     }
 
     @Override
-    public boolean renderWithOverrideTexture(@NotNull final Tessellator tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos, final IconCoordinate textureIndex) {
+    public boolean renderWithOverrideTexture(final @NotNull TessellatorTerrain tessellator, @NotNull final WorldSource worldSource, @NotNull TilePosc tilePos, final IconCoordinate textureIndex) {
         return this.staticModel.renderAttached(this,
             tessellator,
             worldSource,
@@ -66,12 +67,11 @@ public class BlockModelGeneric<T extends BlockLogic> extends BlockModel<T> {
     }
 
     @Override
-    public void renderStandalone(@NotNull final Tessellator tessellator, final int metadata, final float brightness, final float alpha, @Nullable final Integer lightmapCoordinate) {
+    public void renderStandalone(@NotNull final TessellatorGeneral tessellator, final int metadata, final int lightmapCoord) {
         this.staticModel.renderStandalone(this,
             tessellator, 0, 0, 0,
             metadata,
-            BlockColorDispatcher.getInstance().getDispatch(this.block),
-            brightness, alpha);
+            BlockColorDispatcher.getInstance().getDispatch(this.block));
     }
 
     @Override
